searchNodes=[{"doc":"Various helpers and utilities for working with Ash changesets and queries and phoenix.","ref":"AshPhoenix.html","title":"AshPhoenix","type":"module"},{"doc":"A utility to support &quot;add&quot; buttons on embedded types used in forms.To use, simply pass in the form name of the embedded form as well as the name of the primary/outer form.# In your template, inside a form called `:change` &lt;button phx-click=&quot;append_thing&quot; phx-value-path={{form.path}}&gt; &lt;/button&gt; # In the view/component def handle_event(&quot;append_thing&quot;, %{&quot;path&quot; =&gt; path}, socket) do changeset = add_embed(socket.assigns.changeset, path, &quot;change&quot;) {:noreply, assign(socket, changeset: changeset)} endYou can also pass a specific value to be added, to seed the changes in a customized way. By default, %{} is used.","ref":"AshPhoenix.html#add_embed/4","title":"AshPhoenix.add_embed/4","type":"function"},{"doc":"A utility to support &quot;add&quot; buttons on relationships used in forms.To use, simply pass in the form name of the relationship form as well as the name of the primary/outer form.# In your template, inside a form called `:change` &lt;button phx-click=&quot;append_thing&quot; phx-value-path={{form.path}}&gt; &lt;/button&gt; # In the view/component def handle_event(&quot;append_thing&quot;, %{&quot;path&quot; =&gt; path}, socket) do changeset = add_related(socket.assigns.changeset, path, &quot;change&quot;) {:noreply, assign(socket, changeset: changeset)} endOptions* `:add` - the value to add to the relationship, defaults to `%{}` The default value is `%{}`.:relationship - The relationship being updated, in case it can't be determined from the path:id - The value that should be in meta[:id] in the manage changeset opts. Defaults to the relationship name. This only needs to be set if an id is also provided for inputs_for.","ref":"AshPhoenix.html#add_related/4","title":"AshPhoenix.add_related/4","type":"function"},{"doc":"A utility for decoding the path of a form into a list.For example: change[posts][0][comments][1] [&quot;change&quot;, &quot;posts&quot;, 0, &quot;comments&quot;, 1]","ref":"AshPhoenix.html#decode_path/1","title":"AshPhoenix.decode_path/1","type":"function"},{"doc":"Gets all errors on a changeset or query.This honors the AshPhoenix.FormData.Error protocol and applies any transform_errors. See transform_errors/2 for more information.","ref":"AshPhoenix.html#errors_for/2","title":"AshPhoenix.errors_for/2","type":"function"},{"doc":"","ref":"AshPhoenix.html#hide_errors/1","title":"AshPhoenix.hide_errors/1","type":"function"},{"doc":"","ref":"AshPhoenix.html#hiding_errors?/1","title":"AshPhoenix.hiding_errors?/1","type":"function"},{"doc":"A utility to support &quot;remove&quot; buttons on embedded types used in forms.To use, simply pass in the form name of the embedded form as well as the name of the primary/outer form.# In your template, inside a form called `:change` &lt;button phx-click=&quot;remove_thing&quot; phx-value-path={{form.path}}&gt; &lt;/button&gt; # In the view/component def handle_event(&quot;remove_thing&quot;, %{&quot;path&quot; =&gt; path}, socket) do changeset = remove_embed(socket.assigns.changeset, path, &quot;change&quot;) {:noreply, assign(socket, changeset: changeset)} end","ref":"AshPhoenix.html#remove_embed/3","title":"AshPhoenix.remove_embed/3","type":"function"},{"doc":"A utility to support &quot;remove&quot; buttons on relationships used in forms.To use, simply pass in the form name of the related form as well as the name of the primary/outer form.# In your template, inside a form called `:change` &lt;button phx-click=&quot;remove_thing&quot; phx-value-path={{form.path}}&gt; &lt;/button&gt; # In the view/component def handle_event(&quot;remove_thing&quot;, %{&quot;path&quot; =&gt; path}, socket) do {record, changeset} = remove_related(socket.assigns.changeset, path, &quot;change&quot;) {:noreply, assign(socket, record: record, changeset: changeset)} endOptions* `:add` - the value to add to the relationship, defaults to `%{}` The default value is `%{}`.:relationship - The relationship being updated, in case it can't be determined from the path:id - The value that should be in meta[:id] in the manage changeset opts. Defaults to the relationship name. This only needs to be set if an id is also provided for inputs_for.","ref":"AshPhoenix.html#remove_related/4","title":"AshPhoenix.remove_related/4","type":"function"},{"doc":"Allows for manually transforming errors to modify or enable error messages in the form.By default, only errors that implement the AshPhoenix.FormData.Error protocol will show their errors in forms. This is to protect you from showing strange errors to the user. Using this function, you can intercept those errors (as well as ones that do implement the protocol) and return custom form-ready messages for them.Example: AshPhoenix.transform_errors(changeset, fn changeset, %MyApp.CustomError{message: message} -&gt;{:id, &quot;Something went wrong while doing the %{thing}&quot;, [thing: &quot;request&quot;]} end) # Could potentially be used for translation, although not quite ergonomic yet defp translate_error(key, msg, vars) doif vars[:count] do Gettext.dngettext(MyApp.Gettext, &quot;errors&quot;, msg, msg, count, opts) else Gettext.dgettext(MyApp.Gettext, &quot;errors&quot;, msg, opts) end end AshPhoenix.transform_errors(changeset, fnchangeset, %MyApp.CustomError{message: message, field: field} -&gt; translate_error(field, message, [foo: :bar]) changeset, any_error -&gt; if AshPhoenix.FormData.Error.impl_for(any_error) do any_error |&gt; AshPhoenix.FormData.error.to_form_error() |&gt; List.wrap() |&gt; Enum.map(fn {key, msg, vars} -&gt; translate_error(key, msg, vars) end) end end)","ref":"AshPhoenix.html#transform_errors/2","title":"AshPhoenix.transform_errors/2","type":"function"},{"doc":"","ref":"AshPhoenix.FormData.Error.html","title":"AshPhoenix.FormData.Error","type":"protocol"},{"doc":"","ref":"AshPhoenix.FormData.Error.html#to_form_error/1","title":"AshPhoenix.FormData.Error.to_form_error/1","type":"function"},{"doc":"","ref":"AshPhoenix.FormData.Error.html#t:t/0","title":"AshPhoenix.FormData.Error.t/0","type":"type"},{"doc":"Utilities for keeping ash query results up to date in a live view.","ref":"AshPhoenix.LiveView.html","title":"AshPhoenix.LiveView","type":"module"},{"doc":"","ref":"AshPhoenix.LiveView.html#can_link_to_page?/2","title":"AshPhoenix.LiveView.can_link_to_page?/2","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#change_page/3","title":"AshPhoenix.LiveView.change_page/3","type":"function"},{"doc":"Incorporates an Ash.Notifier.Notification into the query results, based on the liveness configuration.You will want to match on receiving a notification from Ash, and the easiest way to do that is to match on the payload like so: @impl true def handle_info(%{topic: topic, payload: %Ash.Notifier.Notification{}}, socket) do {:noreply, handle_live(socket, topic, [:query1, :query2, :query3])} endFeel free to intercept notifications and do your own logic to respond to events. Ultimately, all that matters is that you also call handle_live/3 if you want it to update your query results.The assign or list of assigns passed as the third argument must be the same names passed into keep_live. If you only want some queries to update based on some events, you can define multiple matches on events, and only call handle_live/3 with the assigns that should be updated for that notification.","ref":"AshPhoenix.LiveView.html#handle_live/4","title":"AshPhoenix.LiveView.handle_live/4","type":"function"},{"doc":"Runs the callback, and stores the information required to keep it live in the socket assigns.The data will be assigned to the provided key, e.g keep_live(socket, :me, ...) would assign the results to :me (accessed as @me in the template).Additionally, you'll need to define a handle_info/2 callback for your liveview to receive any notifications, and pass that notification into handle_live/3. See handle_live/3 for more.PaginationTo make paginated views convenient, as well as making it possible to keep those views live, Ash does not simply rerun the query when it gets an update, as that could involve shuffling the records around on the page. Eventually this will be configurable, but for now, Ash simply adjusts the query to only include the records that are on the page. If a record would be removed from a page due to a data change, it will simply be left there. For the best performance, use keyset pagination. If you need the ability to jump to a page by number, you'll want to use offset pagination, but keep in mind that it performs worse on large tables.To support this, accept a second parameter to your callback function, which will be the options to use in page_optsOptions::subscribe - A topic or list of topics that should cause this data to update.:refetch? - A boolean flag indicating whether a refetch is allowed to happen. Defaults to true:results - For list and page queries, by default the records shown are never changed (unless the page changes) The default value is :keep.:load_until_connected? - If the socket is not connected, then the value of the provided assign is set to :loading. Has no effect if initial is provided.:initial - Results to use instead of running the query immediately.:api - For paginated views, in order to use change_page/3, you must set the Api to use for pagination:refetch_interval - An interval (in ms) to periodically refetch the query:refetch_window - The minimum time (in ms) between refetches, including refetches caused by notifications.A great way to get readable millisecond values, you can use the functions in erlang's :timer module, like :timer.hours/1, :timer.minutes/1, and :timer.seconds/1refetch_intervalIf this option is set, a message is sent as {:refetch, assign_name, opts} on that interval. You can then match on that event, like so:def handle_info({:refetch, assign, opts}, socket) do {:noreply, handle_live(socket, :refetch, assign, opts)} endThis is the equivalent of :timer.send_interval(interval, {:refetch, assign, opts}), so feel free to roll your own solution if you have complex refetching requirements.refetch_windowNormally, when a pubsub message is received the query is rerun. This option will cause the query to wait at least this amount of time before doing a refetch. This is accomplished with Process.send_after/4, and recording the last time each query was refetched. For example if a refetch happens at time 0, and the refetch_window is 10,000 ms, we would refetch, and record the time. Then if another refetch should happen 5,000 ms later, we would look and see that we need to wait another 5,000ms. So we use Process.send_after/4 to send a {:refetch, assign, opts} message in 5,000ms. The time that a refetch was requested is tracked, so if the data has since been refetched, it won't be refetched again.Future PlansOne interesting thing here is that, given that we know the scope of data that a resource cares about, we should be able to make optimizations to this code, to support partial refetches, or even just updating the data directly. However, this will need to be carefully considered, as the risks involve showing users data they could be unauthorized to see, or having state in the socket that is inconsistent.","ref":"AshPhoenix.LiveView.html#keep_live/4","title":"AshPhoenix.LiveView.keep_live/4","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#last_page/1","title":"AshPhoenix.LiveView.last_page/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#next_page?/1","title":"AshPhoenix.LiveView.next_page?/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#on_page?/2","title":"AshPhoenix.LiveView.on_page?/2","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_from_params/3","title":"AshPhoenix.LiveView.page_from_params/3","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_link_params/2","title":"AshPhoenix.LiveView.page_link_params/2","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_number/1","title":"AshPhoenix.LiveView.page_number/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_params/1","title":"AshPhoenix.LiveView.page_params/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#prev_page?/1","title":"AshPhoenix.LiveView.prev_page?/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:assign/0","title":"AshPhoenix.LiveView.assign/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:assigns/0","title":"AshPhoenix.LiveView.assigns/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:callback/0","title":"AshPhoenix.LiveView.callback/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:callback_result/0","title":"AshPhoenix.LiveView.callback_result/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:liveness_options/0","title":"AshPhoenix.LiveView.liveness_options/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:socket/0","title":"AshPhoenix.LiveView.socket/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:topic/0","title":"AshPhoenix.LiveView.topic/0","type":"type"},{"doc":"This is a basic plug that loads the current tenant assign from a given value set on subdomain.This was copied from Triplex.SubdomainPlug, here: https://github.com/ateliware/triplex/blob/master/lib/triplex/plugs/subdomain_plug.exOptions::endpoint - Required. The endpoint that the plug is in, used for deterining the host:assign - The key to use when assigning the current tenant The default value is :current_tenant.:handle_subdomain - An mfa to call with the conn and a subdomain value. Can be used to do something like fetch the current user given the tenant. Must return the new conn.To plug it on your router, you can use:plug Ash.SubdomainPlug, endpoint: MyApp.EndpointAn additional helper here can be used for determining the host in your liveview, and/or using the host that was already assigned to the conn.For example:def handle_params(params, uri, socket) do socket = assign_new(socket, :current_tenant, fn -&gt; AshPhoenix.SubdomainPlug.live_tenant(socket, uri) end) socket = assign_new(socket, :current_organization, fn -&gt; if socket.assigns[:current_tenant] do MyApp.Accounts.Api.get!(MyApp.Accounts.Organization, subdomain: socket.assigns[:current_tenant] ) end end) {:noreply, socket} end","ref":"AshPhoenix.SubdomainPlug.html","title":"AshPhoenix.SubdomainPlug","type":"module"},{"doc":"","ref":"AshPhoenix.SubdomainPlug.html#live_tenant/2","title":"AshPhoenix.SubdomainPlug.live_tenant/2","type":"function"},{"doc":"AshPhoenix See the online documentation for AshPhoenix.LiveView for the current set of utilities. This is a new integration, and doesn't do much. Currently, the only thing that is offered are a few helpers for keeping query data live ins ide of live views. There is some experimental code here as well for passing an Ash.Changeset to Phoenix.HTML.form_for/4.Roadmap:UI authorization utilities e.g &lt;%= if authorized_to_do?(resource, action, actor) do %&gt;Potentially helpers for easily connecting buttons to resource actionsForm helpers for using Ash.Changesets with form_fordef deps do [ {:ash_phoenix, &quot;~&gt; 0.4.7&quot;} ] end","ref":"readme.html","title":"AshPhoenix","type":"extras"}]